///////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2018 Leszek Koltunski  leszek@koltunski.pl                                          //
//                                                                                               //
// This file is part of Distorted.                                                               //
//                                                                                               //
// This library is free software; you can redistribute it and/or                                 //
// modify it under the terms of the GNU Lesser General Public                                    //
// License as published by the Free Software Foundation; either                                  //
// version 2.1 of the License, or (at your option) any later version.                            //
//                                                                                               //
// This library is distributed in the hope that it will be useful,                               //
// but WITHOUT ANY WARRANTY; without even the implied warranty of                                //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU                             //
// Lesser General Public License for more details.                                               //
//                                                                                               //
// You should have received a copy of the GNU Lesser General Public                              //
// License along with this library; if not, write to the Free Software                           //
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA                //
///////////////////////////////////////////////////////////////////////////////////////////////////

precision highp float;

out vec4 fragColor;           // The output color
in vec2 v_TexCoordinate;      // Interpolated texture coordinate per fragment.

uniform sampler2D u_Texture;
uniform sampler2D u_DepthTexture;

//////////////////////////////////////////////////////////////////////////////////////////////
// why -0.0003 ? On some drivers (for example Qualcomm's V@331, V@415 on Adreno 308 - also on
// some Mali devices ) without it the depth test - when postprocessing a flat 2D object - does
// not pass (for unknown reasons) and we don't see the Glow halo.  See for example the 'Glowing
// Leaf' test app.
// Why exactly 0.0003? Testing of the Cube app on the SM-A315F. ( Mali G52, drivr r20p0 )
// 0.0003 shouldn't hurt anyway.

void main()                    		
  {
  gl_FragDepth = texture(u_DepthTexture,v_TexCoordinate).r -0.0003;
  fragColor    = texture(u_Texture     ,v_TexCoordinate);
  }